@use './styles/form-input.variations' as variations;
@use './styles/form-input.variables' as *;

:host {
	@include digi-form-input--variables;

	.digi-form-input {
		display: flex;
		flex-direction: column;
		gap: 0.4em;

		&--small {
			@include variations.small;
		}

		&--medium {
			@include variations.medium;
		}

		&--large {
			@include variations.large;
		}

		&--neutral {
			@include variations.neutral;
		}

		&--empty:not(:focus-within) {
			@include variations.empty;
		}

		&--success {
			@include variations.success;
		}

		&--warning {
			@include variations.warning;
		}

		&--error {
			@include variations.error;
		}
	}
}

.digi-form-input__input-wrapper {
	position: relative;
	display: flex;

	::slotted([slot^='button']) {
		button {
			--MIN-HEIGHT: 100%;
		}
	}

	.digi-form-input--button-variation-primary & {
		::slotted([slot^='button']) {
			button {
				border-start-start-radius: 0;
				border-end-start-radius: 0;
			}
		}
	}

	.digi-form-input--button-variation-secondary.digi-form-input--has-button-true & {
		gap: var(--digi--gutter--medium);
		flex-wrap: wrap;
	}
}

.digi-form-input__input {
	flex: 1;
	height: var(--HEIGHT);
	font-family: var(--digi--global--typography--font-family--default);
	font-size: var(--digi--typography--body--font-size--desktop);
	padding: var(--digi--form-input--padding);
	color: var(--digi--color--text--primary);
	background: var(--BACKGROUND);
	border: var(--BORDER);
	border-color: var(--BORDER-COLOR);
	border-radius: var(--digi--form-input--border-radius);
	box-sizing: border-box;

	&:focus-visible {
		box-shadow: var(--digi--focus-shadow);
		outline: var(--digi--focus-outline);
	}

	.digi-form-input--button-variation-primary.digi-form-input--has-button-true & {
		border-end-end-radius: 0;
		border-start-end-radius: 0;
	}
}
